package amidst.map.layers;

import java.util.Arrays;
import java.util.List;
import java.util.Random;

import MoF.Biome;
import MoF.ChunkManager;
import amidst.Log;
import amidst.Options;
import amidst.map.Fragment;
import amidst.map.IconLayer;
import amidst.map.MapObjectNether;
import amidst.map.MapObjectVillage;

public class NetherFortressLayer extends IconLayer {
	private Random random = new Random();
	
	public NetherFortressLayer() {
		super("netherfortress");
		setVisibilityPref(Options.instance.showNetherFortresses);
	}
	public void generateMapObjects(Fragment frag) {
		int size = Fragment.SIZE >> 4;
		for (int x = 0; x < size; x++) {
			for (int y = 0; y < size; y++) {
				int chunkX = x + frag.getChunkX();
				int chunkY = y + frag.getChunkY();
				if (checkChunk(chunkX, chunkY, chunkManager)) {
					frag.addObject(new MapObjectNether(x << 4, y << 4).setParent(this));
				}
			}
		}
	}
	 

	public boolean checkChunk(int chunkX, int chunkY, ChunkManager chunkManager) {
		int i = chunkX >> 4;
		int j = chunkY >> 4;

		random.setSeed((long)(i ^ j << 4) ^ chunkManager.seed);
		random.nextInt();

		if (random.nextInt(3) != 0) {
		  return false;
		}
		if (chunkX != (i << 4) + 4 + random.nextInt(8)) {
		  return false;
		}

		return chunkY == (j << 4) + 4 + random.nextInt(8);
	}
}
